Index: asp3_wo_tecs/trunk/arch/arm_gcc/common/gic_kernel_impl.c
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_gcc/common/gic_kernel_impl.c	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_gcc/common/gic_kernel_impl.c	(revision 306)
@@ -1,6 +1,5 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
  *
  *  Copyright (C) 2006-2016 by Embedded and Real-Time Systems Laboratory
@@ -51,5 +50,5 @@
  *  ã®è²¬ä»»ãè² ããªãï¼
  * 
- *  $Id: gic_kernel_impl.c 522 2016-01-14 06:56:53Z ertl-hiro $
+ *  $Id: gic_kernel_impl.c 714 2016-03-31 05:52:19Z ertl-hiro $
  */
 
@@ -138,5 +137,5 @@
 	 *  ãã¹ã¦ã®å²è¾¼ã¿ãã°ã«ã¼ã1ï¼IRQï¼ã«è¨­å®
 	 */
-	for (i = 0; i < GIC_TNUM_INTNO / 32; i++) {
+	for (i = 0; i < (GIC_TNUM_INTNO + 31) / 32; i++) {
 		sil_wrw_mem(GICD_IGROUPR(i), 0xffffffffU);
 	}
@@ -146,5 +145,5 @@
 	 *  ãã¹ã¦ã®å²è¾¼ã¿ãç¦æ­¢
 	 */
-	for (i = 0; i < GIC_TNUM_INTNO / 32; i++) {
+	for (i = 0; i < (GIC_TNUM_INTNO + 31) / 32; i++) {
 		sil_wrw_mem(GICD_ICENABLER(i), 0xffffffffU);
 	}
@@ -153,5 +152,5 @@
 	 *  ãã¹ã¦ã®å²è¾¼ã¿ãã³ãã£ã³ã°ãã¯ãªã¢
 	 */
-	for (i = 0; i < GIC_TNUM_INTNO / 32; i++) {
+	for (i = 0; i < (GIC_TNUM_INTNO + 31) / 32; i++) {
 		sil_wrw_mem(GICD_ICPENDR(i), 0xffffffffU);
 	}
@@ -161,5 +160,5 @@
 åº¦ã«è¨­å®
 	 */
-	for (i = 0; i < GIC_TNUM_INTNO / 4; i++){
+	for (i = 0; i < (GIC_TNUM_INTNO + 3) / 4; i++){
 		sil_wrw_mem(GICD_IPRIORITYR(i), 0xffffffffU);
 	}
@@ -169,5 +168,5 @@
 ±æããªãã§ã©ã«å²è¾¼ã¿ã®ã¿ã¼ã²ããããã­ã»ããµ0ã«è¨­å®
 	 */
-	for (i = GIC_INTNO_SPI0 / 4; i < GIC_TNUM_INTNO / 4; i++) {
+	for (i = GIC_INTNO_SPI0 / 4; i < (GIC_TNUM_INTNO + 3) / 4; i++) {
 		sil_wrw_mem(GICD_ITARGETSR(i), 0x01010101U);
 	}
@@ -176,5 +175,5 @@
 	 *  ãã¹ã¦ã®ããªãã§ã©ã«å²è¾¼ã¿ãã¬ãã«ããªã¬ã«è¨­å®
 	 */
-	for (i = GIC_INTNO_PPI0 / 16; i < GIC_TNUM_INTNO / 16; i++) {
+	for (i = GIC_INTNO_PPI0 / 16; i < (GIC_TNUM_INTNO + 15) / 16; i++) {
 #ifdef GIC_ARM11MPCORE
 		sil_wrw_mem(GICD_ICFGR(i), 0x55555555U);
@@ -198,4 +197,6 @@
 	sil_wrw_mem(GICD_CTLR, GICD_CTLR_DISABLE);
 }
+
+#ifndef OMIT_GIC_INITIALIZE_INTERRUPT
 
 /*
@@ -273,2 +274,4 @@
 	}
 }
+
+#endif /* OMIT_GIC_INITIALIZE_INTERRUPT */
Index: asp3_wo_tecs/trunk/arch/arm_gcc/common/gic_kernel_impl.h
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_gcc/common/gic_kernel_impl.h	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_gcc/common/gic_kernel_impl.h	(revision 306)
@@ -1,6 +1,5 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
  *  Copyright (C) 2006-2016 by Embedded and Real-Time Systems Laboratory
@@ -51,5 +50,5 @@
  *  ã®è²¬ä»»ãè² ããªãï¼
  * 
- *  $Id: gic_kernel_impl.h 535 2016-01-16 00:42:29Z ertl-hiro $
+ *  $Id: gic_kernel_impl.h 714 2016-03-31 05:52:19Z ertl-hiro $
  */
 
@@ -176,18 +175,18 @@
 #define GICD_TYPER			GIC_REG(GICD_BASE, 0x004)
 #define GICD_IIDR			GIC_REG(GICD_BASE, 0x008)
-#define GICD_IGROUPR(n)		GIC_REG(GICD_BASE, 0x080 + n * 4)
-#define GICD_ISENABLER(n)	GIC_REG(GICD_BASE, 0x100 + n * 4)
-#define GICD_ICENABLER(n)	GIC_REG(GICD_BASE, 0x180 + n * 4)
-#define GICD_ISPENDR(n)		GIC_REG(GICD_BASE, 0x200 + n * 4)
-#define GICD_ICPENDR(n)		GIC_REG(GICD_BASE, 0x280 + n * 4)
-#define GICD_ISACTIVER(n)	GIC_REG(GICD_BASE, 0x300 + n * 4)
-#define GICD_ICACTIVER(n)	GIC_REG(GICD_BASE, 0x380 + n * 4)
-#define GICD_IPRIORITYR(n)	GIC_REG(GICD_BASE, 0x400 + n * 4)
-#define GICD_ITARGETSR(n)	GIC_REG(GICD_BASE, 0x800 + n * 4)
-#define GICD_ICFGR(n)		GIC_REG(GICD_BASE, 0xc00 + n * 4)
-#define GICD_NSCAR(n)		GIC_REG(GICD_BASE, 0xe00 + n * 4)
+#define GICD_IGROUPR(n)		GIC_REG(GICD_BASE, 0x080 + (n) * 4)
+#define GICD_ISENABLER(n)	GIC_REG(GICD_BASE, 0x100 + (n) * 4)
+#define GICD_ICENABLER(n)	GIC_REG(GICD_BASE, 0x180 + (n) * 4)
+#define GICD_ISPENDR(n)		GIC_REG(GICD_BASE, 0x200 + (n) * 4)
+#define GICD_ICPENDR(n)		GIC_REG(GICD_BASE, 0x280 + (n) * 4)
+#define GICD_ISACTIVER(n)	GIC_REG(GICD_BASE, 0x300 + (n) * 4)
+#define GICD_ICACTIVER(n)	GIC_REG(GICD_BASE, 0x380 + (n) * 4)
+#define GICD_IPRIORITYR(n)	GIC_REG(GICD_BASE, 0x400 + (n) * 4)
+#define GICD_ITARGETSR(n)	GIC_REG(GICD_BASE, 0x800 + (n) * 4)
+#define GICD_ICFGR(n)		GIC_REG(GICD_BASE, 0xc00 + (n) * 4)
+#define GICD_NSCAR(n)		GIC_REG(GICD_BASE, 0xe00 + (n) * 4)
 #define GICD_SGIR			GIC_REG(GICD_BASE, 0xf00)
-#define GICD_CPENDSGIR(n)	GIC_REG(GICD_BASE, 0xf10 + n * 4)
-#define GICD_SPENDSGIR(n)	GIC_REG(GICD_BASE, 0xf20 + n * 4)
+#define GICD_CPENDSGIR(n)	GIC_REG(GICD_BASE, 0xf10 + (n) * 4)
+#define GICD_SPENDSGIR(n)	GIC_REG(GICD_BASE, 0xf20 + (n) * 4)
 
 /*
@@ -200,7 +199,8 @@
  *  å²è¾¼ã¿ã³ã³ãã£ã®ã¥ã¬ã¼ã·ã§ã³ã¬ã¸ã¹ã¿ï¼GICD_ICFGRnï¼ã®è¨­å®å¤
  *
- *  ç¬¬1ãããã¯ï¼ARM11 MPCoreã§ã¯å²è¾¼ã¿ã®éç¥å
-ãã­ã»ããµãè¨­å®ãããã
- *  ã«ä½¿ç¨ããã¦ãããï¼GICv1ããã³GICv2ã§ã¯äºç´ãããã¨ãªã£ã¦ããï¼
+ *  ç¬¬1ãããã¯ï¼ARM11 MPCoreããã³GICã®æ©ãææã®å®è£
+ã§ã¯å²è¾¼ã¿ã®éç¥
+ *  å
+ãã­ã»ããµãè¨­å®ããããã«ä½¿ç¨ããã¦ããï¼
  */
 #define GICD_ICFGRn_LEVEL	UINT_C(0x00)
Index: asp3_wo_tecs/trunk/arch/arm_gcc/common/gic_support.S
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_gcc/common/gic_support.S	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_gcc/common/gic_support.S	(revision 306)
@@ -1,6 +1,5 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
@@ -53,5 +52,5 @@
  *  ã®è²¬ä»»ãè² ããªãï¼
  * 
- *  $Id: gic_support.S 522 2016-01-14 06:56:53Z ertl-hiro $
+ *  $Id: gic_support.S 718 2016-04-01 15:05:01Z ertl-hiro $
  */
 
@@ -79,5 +78,6 @@
 å ±ï¼å²è¾¼ã¿çºçåã®å²è¾¼ã¿
  *  åªå
-åº¦ãã¹ã¯ï¼ãï¼ã¹ã¿ãã¯ã«ä¿å­ããï¼
+åº¦ãã¹ã¯ï¼ãï¼ã¹ã¿ãã¯ã®å
+é ­ã«ä¿å­ããï¼
  */
 	ATEXT
@@ -104,14 +104,8 @@
 	str		r0, [r1]			/* æ°ããå²è¾¼ã¿åªå
 åº¦ãã¹ã¯ãã»ãããã */
-//	DATA_SYNC_BARRIER			/* å²è¾¼ã¿åªå
+	asm_data_sync_barrier r0	/* å²è¾¼ã¿åªå
 åº¦ãã¹ã¯ãã»ãããããã®ãå¾
 ã¤ */
-#if __TARGET_ARCH_ARM == 6
-	mov		r0, #0
-	mcr		p15, 0, r0, c7, c10, 4
-#elif __TARGET_ARCH_ARM == 7
-	dsb
-#endif /* __TARGET_ARCH_ARM == 7 */
-	push	{r2}				/* irc_end_intã§ç¨ããæ
+	str		r2, [sp]			/* irc_end_intã§ç¨ããæ
 å ±ãä¿å­ */
 
@@ -141,5 +135,5 @@
 ã«æ»ãï¼
 	 */
-	pop		{r2}				/* irc_begin_intã§ä¿å­ããæ
+	ldr		r2, [sp]			/* irc_begin_intã§ä¿å­ããæ
 å ±ãå¾©å¸° */
 	ldr		r1, =GICC_PMR		/* å²è¾¼ã¿åªå
@@ -178,5 +172,6 @@
 å ±ï¼CPUä¾å¤çºçåã®å²è¾¼ã¿åªå
 åº¦ãã¹ã¯ï¼ãï¼ã¹ã¿ã
- *	ã¯ã«ä¿å­ããï¼
+ *	ã¯ã®å
+é ­ã«ä¿å­ããï¼
  */
 	ATEXT
@@ -191,5 +186,5 @@
 åº¦ãåå¾ */
 	ldr		r2, [r1]
-	push	{r2}				/* irc_end_excã§ç¨ããæ
+	str		r2, [sp]			/* irc_end_excã§ç¨ããæ
 å ±ãä¿å­ */
 	bx		lr
@@ -207,5 +202,5 @@
 ã«æ»ãï¼
 	 */
-	pop		{r2}				/* irc_begin_excã§ä¿å­ããæ
+	ldr		r2, [sp]			/* irc_begin_excã§ä¿å­ããæ
 å ±ãå¾©å¸° */
 	ldr		r1, =GICC_PMR		/* å²è¾¼ã¿åªå
Index: asp3_wo_tecs/trunk/arch/arm_gcc/common/pl310.c
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_gcc/common/pl310.c	(revision 306)
+++ asp3_wo_tecs/trunk/arch/arm_gcc/common/pl310.c	(revision 306)
@@ -0,0 +1,185 @@
+/*
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
+ * 
+ *  Copyright (C) 2013-2016 by Embedded and Real-Time Systems Laboratory
+ *              Graduate School of Information Science, Nagoya Univ., JAPAN
+ * 
+ *  ä¸è¨èä½æ¨©è
+ã¯ï¼ä»¥ä¸ã®(1)ï½(4)ã®æ¡ä»¶ãæºããå ´åã«éãï¼æ¬ã½ããã¦ã§
+ *  ã¢ï¼æ¬ã½ããã¦ã§ã¢ãæ¹å¤ãããã®ãå«ãï¼ä»¥ä¸åãï¼ãä½¿ç¨ã»è¤è£½ã»æ¹
+ *  å¤ã»åé
+å¸ï¼ä»¥ä¸ï¼å©ç¨ã¨å¼ã¶ï¼ãããã¨ãç¡åã§è¨±è«¾ããï¼
+ *  (1) æ¬ã½ããã¦ã§ã¢ãã½ã¼ã¹ã³ã¼ãã®å½¢ã§å©ç¨ããå ´åã«ã¯ï¼ä¸è¨ã®èä½
+ *      æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãï¼ãã®ã¾ã¾ã®å½¢ã§ã½ã¼
+ *      ã¹ã³ã¼ãä¸­ã«å«ã¾ãã¦ãããã¨ï¼
+ *  (2) æ¬ã½ããã¦ã§ã¢ãï¼ã©ã¤ãã©ãªå½¢å¼ãªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+ *      ç¨ã§ããå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨
+ *      è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®èä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨
+ *      ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+ *  (3) æ¬ã½ããã¦ã§ã¢ãï¼æ©å¨ã«çµã¿è¾¼ããªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+ *      ç¨ã§ããªãå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼æ¬¡ã®ããããã®æ¡ä»¶ãæºããã
+ *      ã¨ï¼
+ *    (a) åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®è
+ *        ä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+ *    (b) åé
+å¸ã®å½¢æ
+ãï¼å¥ã«å®ããæ¹æ³ã«ãã£ã¦ï¼TOPPERSãã­ã¸ã§ã¯ãã«
+ *        å ±åãããã¨ï¼
+ *  (4) æ¬ã½ããã¦ã§ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæ
+ *      å®³ãããï¼ä¸è¨èä½æ¨©è
+ããã³TOPPERSãã­ã¸ã§ã¯ããå
+è²¬ãããã¨ï¼
+ *      ã¾ãï¼æ¬ã½ããã¦ã§ã¢ã®ã¦ã¼ã¶ã¾ãã¯ã¨ã³ãã¦ã¼ã¶ããã®ãããªãç
+ *      ç±ã«åºã¥ãè«æ±ãããï¼ä¸è¨èä½æ¨©è
+ããã³TOPPERSãã­ã¸ã§ã¯ãã
+ *      å
+è²¬ãããã¨ï¼
+ * 
+ *  æ¬ã½ããã¦ã§ã¢ã¯ï¼ç¡ä¿è¨¼ã§æä¾ããã¦ãããã®ã§ããï¼ä¸è¨èä½æ¨©è
+ã
+ *  ãã³TOPPERSãã­ã¸ã§ã¯ãã¯ï¼æ¬ã½ããã¦ã§ã¢ã«é¢ãã¦ï¼ç¹å®ã®ä½¿ç¨ç®ç
+ *  ã«å¯¾ããé©åæ§ãå«ãã¦ï¼ãããªãä¿è¨¼ãè¡ããªãï¼ã¾ãï¼æ¬ã½ããã¦ã§
+ *  ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæå®³ã«é¢ãã¦ãï¼ã
+ *  ã®è²¬ä»»ãè² ããªãï¼
+ * 
+ *  $Id$
+ */
+
+/*
+ *		L2ã­ã£ãã·ã¥ã³ã³ãã­ã¼ã©ï¼PL310ï¼ã®æä½ã©ã¤ãã©ãª
+ */
+
+#include "kernel_impl.h"
+#include "pl310.h"
+
+Inline uint32_t
+get_way_mask(void)
+{
+	uint32_t	aux;
+	
+	aux = sil_rew_mem(PL310_AUX_CTRL);
+	if ((aux & PL310_AUX_CTRL_ASSOCIATIVITY) != 0U) {
+		/* 16ã¦ã§ã¤ */
+		return(0x0000ffffU);
+	}
+	else {
+		/* 8ã¦ã§ã¤ */
+		return(0x000000ffU);
+	}
+}
+
+Inline void
+pl310_cache_sync(void)
+{
+	sil_wrw_mem(PL310_CACHE_SYNC, 0);
+}
+
+Inline void
+pl310_inv_all(void)
+{
+	uint32_t	way_mask = get_way_mask();
+
+	/* ãã¹ã¦ã®ã¦ã§ã¤ãç¡å¹åãã */
+	sil_wrw_mem(PL310_INV_WAY, 0xffff);
+	while ((sil_rew_mem(PL310_INV_WAY) & way_mask) != 0U) ;
+	pl310_cache_sync();
+}
+
+Inline void
+pl310_debug_set(uint32_t val)
+{
+	sil_wrw_mem(PL310_DEBUG_CTRL, val);
+}
+
+/*
+ *  PL310ã®åæå
+ */
+void
+pl310_initialize(uint32_t aux_val, uint32_t aux_mask)
+{
+	uint32_t	aux;
+	uint32_t	prefetch;
+	uint32_t	prefetch_val = 0U;
+
+	/* L2ã­ã£ãã·ã¥ããã£ã¹ã¨ã¼ãã«ã®å ´åã®ã¿åæåãè¡ã */
+	if ((sil_rew_mem(PL310_CTRL) & 0x01) == 0U) {
+		/* å
+±æå±æ§ãç¡è¦ãã */
+		aux_val |= PL310_AUX_CTRL_IGNORE_SHARE;
+
+		/* å½ä»¤ããªãã§ãããã¤ãã¼ãã« */
+		aux_val |= PL310_AUX_CTRL_INST_PREFETCH;
+		prefetch_val |= PL310_AUX_CTRL_INST_PREFETCH;
+
+		/* ãã¼ã¿ããªãã§ãããã¤ãã¼ãã« */
+		aux_val |= PL310_AUX_CTRL_DATA_PREFETCH;
+		prefetch_val |= PL310_AUX_CTRL_DATA_PREFETCH;
+
+		/* ããã«ã©ã¤ã³ãã£ã«ãã¤ãã¼ãã« */
+		prefetch_val |= PL310_PREFETCH_CTRL_DLINEFILL;
+		prefetch_val |= PL310_PREFETCH_CTRL_INCR_DLINEFILL;
+                
+		/* è£å©å¶å¾¡ã¬ã¸ã¹ã¿ãè¨­å® */
+		aux = sil_rew_mem(PL310_AUX_CTRL);
+		sil_wrw_mem(PL310_AUX_CTRL, ((aux & aux_mask) | aux_val));
+
+		/* ããªãã§ããå¶å¾¡ã¬ã¸ã¹ã¿ãè¨­å® */
+		prefetch = sil_rew_mem(PL310_PREFETCH_CTRL);
+		sil_wrw_mem(PL310_PREFETCH_CTRL, (prefetch | prefetch_val));
+
+		/* L2ã­ã£ãã·ã¥ã®å
+¨ä½ã®ç¡å¹å */
+		pl310_inv_all();
+        
+		/* ã¯ã­ãã¯ã²ã¼ãã£ã³ã°ã¨ã¹ã¿ã³ãã¤ã¢ã¼ããã¤ãã¼ãã« */
+		sil_wrw_mem(PL310_POWER_CTRL, 0x03);
+        
+		/* L2ã­ã£ãã·ã¥ã®ã¤ãã¼ãã« */
+		sil_wrw_mem(PL310_CTRL, 0x01);
+	}    
+}
+
+/*
+ *  L2ã­ã£ãã·ã¥ã®ãã£ã¹ã¨ã¼ãã«
+ */
+void
+pl310_disable(void)
+{
+	pl310_clean_and_invalidate_all();
+	sil_wrw_mem(PL310_CTRL, 0x00);
+}
+
+/*
+ *  L2ã­ã£ãã·ã¥å
+¨ä½ã®ç¡å¹åï¼æ¸ãæ»ããªãï¼
+ */
+void
+pl310_invalidate_all(void)
+{
+	pl310_debug_set(0x03);
+	pl310_inv_all();
+	pl310_debug_set(0x00);
+}
+
+/*
+ *  L2ã­ã£ãã·ã¥å
+¨ä½ã®ã¯ãªã¼ã³ã¨ç¡å¹å
+ */
+void
+pl310_clean_and_invalidate_all(void)
+{
+	uint32_t	way_mask = get_way_mask();
+
+	pl310_debug_set(0x03);
+	sil_wrw_mem(PL310_CLEAN_INV_WAY, way_mask);
+	while ((sil_rew_mem(PL310_CLEAN_INV_WAY) & way_mask) != 0U) ;
+	pl310_cache_sync();
+	pl310_debug_set(0x00);
+}
Index: asp3_wo_tecs/trunk/arch/arm_gcc/common/pl310.h
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_gcc/common/pl310.h	(revision 306)
+++ asp3_wo_tecs/trunk/arch/arm_gcc/common/pl310.h	(revision 306)
@@ -0,0 +1,148 @@
+/*
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
+ * 
+ *  Copyright (C) 2013-2016 by Embedded and Real-Time Systems Laboratory
+ *              Graduate School of Information Science, Nagoya Univ., JAPAN
+ * 
+ *  ä¸è¨èä½æ¨©è
+ã¯ï¼ä»¥ä¸ã®(1)ï½(4)ã®æ¡ä»¶ãæºããå ´åã«éãï¼æ¬ã½ããã¦ã§
+ *  ã¢ï¼æ¬ã½ããã¦ã§ã¢ãæ¹å¤ãããã®ãå«ãï¼ä»¥ä¸åãï¼ãä½¿ç¨ã»è¤è£½ã»æ¹
+ *  å¤ã»åé
+å¸ï¼ä»¥ä¸ï¼å©ç¨ã¨å¼ã¶ï¼ãããã¨ãç¡åã§è¨±è«¾ããï¼
+ *  (1) æ¬ã½ããã¦ã§ã¢ãã½ã¼ã¹ã³ã¼ãã®å½¢ã§å©ç¨ããå ´åã«ã¯ï¼ä¸è¨ã®èä½
+ *      æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãï¼ãã®ã¾ã¾ã®å½¢ã§ã½ã¼
+ *      ã¹ã³ã¼ãä¸­ã«å«ã¾ãã¦ãããã¨ï¼
+ *  (2) æ¬ã½ããã¦ã§ã¢ãï¼ã©ã¤ãã©ãªå½¢å¼ãªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+ *      ç¨ã§ããå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨
+ *      è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®èä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨
+ *      ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+ *  (3) æ¬ã½ããã¦ã§ã¢ãï¼æ©å¨ã«çµã¿è¾¼ããªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+ *      ç¨ã§ããªãå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼æ¬¡ã®ããããã®æ¡ä»¶ãæºããã
+ *      ã¨ï¼
+ *    (a) åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®è
+ *        ä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+ *    (b) åé
+å¸ã®å½¢æ
+ãï¼å¥ã«å®ããæ¹æ³ã«ãã£ã¦ï¼TOPPERSãã­ã¸ã§ã¯ãã«
+ *        å ±åãããã¨ï¼
+ *  (4) æ¬ã½ããã¦ã§ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæ
+ *      å®³ãããï¼ä¸è¨èä½æ¨©è
+ããã³TOPPERSãã­ã¸ã§ã¯ããå
+è²¬ãããã¨ï¼
+ *      ã¾ãï¼æ¬ã½ããã¦ã§ã¢ã®ã¦ã¼ã¶ã¾ãã¯ã¨ã³ãã¦ã¼ã¶ããã®ãããªãç
+ *      ç±ã«åºã¥ãè«æ±ãããï¼ä¸è¨èä½æ¨©è
+ããã³TOPPERSãã­ã¸ã§ã¯ãã
+ *      å
+è²¬ãããã¨ï¼
+ * 
+ *  æ¬ã½ããã¦ã§ã¢ã¯ï¼ç¡ä¿è¨¼ã§æä¾ããã¦ãããã®ã§ããï¼ä¸è¨èä½æ¨©è
+ã
+ *  ãã³TOPPERSãã­ã¸ã§ã¯ãã¯ï¼æ¬ã½ããã¦ã§ã¢ã«é¢ãã¦ï¼ç¹å®ã®ä½¿ç¨ç®ç
+ *  ã«å¯¾ããé©åæ§ãå«ãã¦ï¼ãããªãä¿è¨¼ãè¡ããªãï¼ã¾ãï¼æ¬ã½ããã¦ã§
+ *  ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæå®³ã«é¢ãã¦ãï¼ã
+ *  ã®è²¬ä»»ãè² ããªãï¼
+ * 
+ *  $Id$
+ */
+
+/*
+ *		L2ã­ã£ãã·ã¥ã³ã³ãã­ã¼ã©ï¼PL310ï¼ã«é¢ããå®ç¾©
+ */
+
+#ifndef TOPPERS_PL310_H
+#define TOPPERS_PL310_H
+
+/*
+ *  åã­ã£ã¹ããè¡ããã¯ã­ã®å®ç¾©
+ */
+#ifndef CAST
+#define CAST(type, val)		((type)(val))
+#endif /* CAST */
+
+/*
+ *  PL310ã®ã¬ã¸ã¹ã¿ã®çªå°ã®å®ç¾©
+ */
+#define PL310_CACHE_ID			CAST(uint32_t *, PL310_BASE + 0x000)
+#define PL310_CACHE_TYPE		CAST(uint32_t *, PL310_BASE + 0x004)
+#define PL310_CTRL				CAST(uint32_t *, PL310_BASE + 0x100)
+#define PL310_AUX_CTRL			CAST(uint32_t *, PL310_BASE + 0x104)
+#define PL310_TAG_RAM_CTRL		CAST(uint32_t *, PL310_BASE + 0x108)
+#define PL310_DATA_RAM_CTRL		CAST(uint32_t *, PL310_BASE + 0x10c)
+#define PL310_EVENT_CNT_CTRL	CAST(uint32_t *, PL310_BASE + 0x200)
+#define PL310_EVENT_CNT1_CFG	CAST(uint32_t *, PL310_BASE + 0x204)
+#define PL310_EVENT_CNT0_CFG	CAST(uint32_t *, PL310_BASE + 0x208)
+#define PL310_EVENT_CNT1		CAST(uint32_t *, PL310_BASE + 0x20c)
+#define PL310_EVENT_CNT0		CAST(uint32_t *, PL310_BASE + 0x210)
+#define PL310_INT_MASK			CAST(uint32_t *, PL310_BASE + 0x214)
+#define PL310_INT_MASK_STAT		CAST(uint32_t *, PL310_BASE + 0x218)
+#define PL310_INT_RAW_STAT		CAST(uint32_t *, PL310_BASE + 0x21c)
+#define PL310_INT_CLEAR			CAST(uint32_t *, PL310_BASE + 0x220)
+#define PL310_CACHE_SYNC		CAST(uint32_t *, PL310_BASE + 0x730)
+#define PL310_INV_PA			CAST(uint32_t *, PL310_BASE + 0x770)
+#define PL310_INV_WAY			CAST(uint32_t *, PL310_BASE + 0x77c)
+#define PL310_CLEAN_PA			CAST(uint32_t *, PL310_BASE + 0x7b0)
+#define PL310_CLEAN_IDX			CAST(uint32_t *, PL310_BASE + 0x7b8)
+#define PL310_CLEAN_WAY			CAST(uint32_t *, PL310_BASE + 0x7bc)
+#define PL310_CLEAN_INV_PA		CAST(uint32_t *, PL310_BASE + 0x7f0)
+#define PL310_CLEAN_INV_IDX		CAST(uint32_t *, PL310_BASE + 0x7f8)
+#define PL310_CLEAN_INV_WAY		CAST(uint32_t *, PL310_BASE + 0x7Fc)
+#define PL310_D_LOCKDOWN0		CAST(uint32_t *, PL310_BASE + 0x900)
+#define PL310_I_LOCKDOWN0		CAST(uint32_t *, PL310_BASE + 0x904)
+#define PL310_DEBUG_CTRL		CAST(uint32_t *, PL310_BASE + 0xf40)
+#define PL310_PREFETCH_CTRL		CAST(uint32_t *, PL310_BASE + 0xf60)
+#define PL310_POWER_CTRL		CAST(uint32_t *, PL310_BASE + 0xf80)
+
+/*
+ *  ã­ã£ãã·ã¥è£å©å¶å¾¡ã¬ã¸ã¹ã¿ï¼PL310_AUX_CTRLï¼ã®è¨­å®å¤
+ */
+#define PL310_AUX_CTRL_ASSOCIATIVITY		0x00010000
+#define PL310_AUX_CTRL_WAY_SIZE_SHIFT		17
+#define PL310_AUX_CTRL_WAY_SIZE_MASK		0x000e0000
+#define PL310_AUX_CTRL_IGNORE_SHARE			0x00400000
+#define PL310_AUX_CTRL_NS_LOCKDOWN			0x04000000
+#define PL310_AUX_CTRL_NS_INT_CTRL			0x08000000
+#define PL310_AUX_CTRL_DATA_PREFETCH		0x10000000
+#define PL310_AUX_CTRL_INST_PREFETCH		0x20000000
+#define PL310_AUX_CTRL_EARLY_BRESP			0x40000000
+
+/*
+ *  ããªãã§ããå¶å¾¡ã¬ã¸ã¹ã¿ï¼PL310_PREFETCH_CTRLï¼ã®è¨­å®å¤
+ */
+#define PL310_PREFETCH_CTRL_INCR_DLINEFILL	0x00800000
+#define PL310_PREFETCH_CTRL_DATA_PREFETCH	0x10000000
+#define PL310_PREFETCH_CTRL_INST_PREFETCH	0x20000000
+#define PL310_PREFETCH_CTRL_DLINEFILL		0x40000000
+
+#ifndef TOPPERS_MACRO_ONLY
+
+/*
+ *  L2ã­ã£ãã·ã¥ã®åæåã¨ã¤ãã¼ãã«
+ */
+extern void pl310_initialize(uint32_t aux_val, uint32_t aux_mask);
+
+/*
+ *  L2ã­ã£ãã·ã¥ã®ãã£ã¹ã¨ã¼ãã«
+ */
+extern void pl310_disable(void);
+
+/*
+ *  L2ã­ã£ãã·ã¥å
+¨ä½ã®ç¡å¹åï¼æ¸ãæ»ããªãï¼
+ */
+extern void pl310_invalidate_all(void);
+
+/*
+ *  L2ã­ã£ãã·ã¥å
+¨ä½ã®ã¯ãªã¼ã³ã¨ç¡å¹å
+ */
+extern void pl310_clean_and_invalidate_all(void);
+
+#endif /* TOPPERS_MACRO_ONLY */
+#endif /* TOPPERS_PL310_H */
Index: asp3_wo_tecs/trunk/arch/arm_gcc/common/uart_pl011.h
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_gcc/common/uart_pl011.h	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_gcc/common/uart_pl011.h	(revision 306)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2006-2015 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2006-2016 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -53,5 +53,5 @@
  *  ã®è²¬ä»»ãè² ããªãï¼
  * 
- *  $Id: uart_pl011.h 359 2015-07-26 10:27:20Z ertl-hiro $
+ *  $Id: uart_pl011.h 509 2016-01-12 06:06:14Z ertl-hiro $
  */
 
Index: asp3_wo_tecs/trunk/arch/arm_m_gcc/common/Makefile.core
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_m_gcc/common/Makefile.core	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_m_gcc/common/Makefile.core	(revision 306)
@@ -95,5 +95,5 @@
 
 #
-#  ãªãã»ãããã¡ã¤ã«çæã®ããã®å®ç¾©(ToDo)
+#  ãªãã»ãããã¡ã¤ã«çæã®ããã®å®ç¾©
 #
 TARGET_OFFSET_TRB = $(COREDIR)/core_offset.trb
Index: asp3_wo_tecs/trunk/arch/arm_m_gcc/common/core_check.trb
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_m_gcc/common/core_check.trb	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_m_gcc/common/core_check.trb	(revision 306)
@@ -1,13 +1,13 @@
 # ======================================================================
-# 
+#
 #   TOPPERS/ASP Kernel
 #       Toyohashi Open Platform for Embedded Real-Time Systems/
 #       Advanced Standard Profile Kernel
-#  
+#
 #   Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 #                               Toyohashi Univ. of Technology, JAPAN
 #   Copyright (C) 2005-2014 by Embedded and Real-Time Systems Laboratory
 #               Graduate School of Information Science, Nagoya Univ., JAPAN
-#  
+#
 #   ä¸è¨èä½æ¨©è
 ã¯ï¼ä»¥ä¸ã®(1)ã(4)ã®æ¡ä»¶ãæºããå ´åã«éãï¼æ¬ã½ããã¦ã§
@@ -46,5 +46,5 @@
 #       å
 è²¬ãããã¨ï¼
-#  
+#
 #   æ¬ã½ããã¦ã§ã¢ã¯ï¼ç¡ä¿è¨¼ã§æä¾ããã¦ãããã®ã§ããï¼ä¸è¨èä½æ¨©è
 ã
@@ -53,19 +53,17 @@
 #   ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæå®³ã«é¢ãã¦ãï¼ã
 #   ã®è²¬ä»»ãè² ããªãï¼
-# 
+#
 #   @(#) $Id: core_check.tf 301 2015-01-07 04:57:01Z ertl-ishikawa $
 #
 # =====================================================================
 
-# 
+#
 # 		ãã¹3ã®ãã­ã»ããµä¾å­ãã³ãã¬ã¼ãï¼ARM-Mç¨ï¼
-# 
+#
 
-# 
+#
 #  ãã¹4ã®ãã­ã»ããµä¾å­ãã³ãã¬ã¼ãï¼ARM-Mç¨ï¼
-#  
-def GetStackTskinictxb(key, params)
-    tinib = SYMBOL("_kernel_tinib_table")
-    tinib += $sizeof_TINIB * (key - 1)
+#
+def GetStackTskinictxb(key, params, tinib)
     bottom = PEEK(tinib + $offsetof_TINIB_TSKINICTXB_stk_bottom, $sizeof_void_ptr)
     size = PEEK(tinib + $offsetof_TINIB_TSKINICTXB_stksz, $sizeof_size_t)
@@ -73,6 +71,6 @@
 end
 
-# 
+#
 #  ã¿ã¼ã²ããéä¾å­é¨ã®ã¤ã³ã¯ã«ã¼ã
-# 
+#
 IncludeTrb("kernel/kernel_check.trb")
Index: asp3_wo_tecs/trunk/arch/arm_m_gcc/common/core_kernel.trb
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_m_gcc/common/core_kernel.trb	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_m_gcc/common/core_kernel.trb	(revision 306)
@@ -1,13 +1,13 @@
 # ======================================================================
-# 
+#
 #   TOPPERS/ASP Kernel
 #       Toyohashi Open Platform for Embedded Real-Time Systems/
 #       Advanced Standard Profile Kernel
-#  
+#
 #   Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 #                               Toyohashi Univ. of Technology, JAPAN
 #   Copyright (C) 2005-2015 by Embedded and Real-Time Systems Laboratory
 #               Graduate School of Information Science, Nagoya Univ., JAPAN
-#  
+#
 #   ä¸è¨èä½æ¨©è
 ã¯ï¼ä»¥ä¸ã®(1)ã(4)ã®æ¡ä»¶ãæºããå ´åã«éãï¼æ¬ã½ããã¦ã§
@@ -46,5 +46,5 @@
 #       å
 è²¬ãããã¨ï¼
-#  
+#
 #   æ¬ã½ããã¦ã§ã¢ã¯ï¼ç¡ä¿è¨¼ã§æä¾ããã¦ãããã®ã§ããï¼ä¸è¨èä½æ¨©è
 ã
@@ -53,38 +53,38 @@
 #   ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæå®³ã«é¢ãã¦ãï¼ã
 #   ã®è²¬ä»»ãè² ããªãï¼
-# 
+#
 #   @(#) $Id: core.tf 322 2015-04-30 13:23:48Z ertl-ishikawa $
 #
 # =====================================================================
 
-# 
+#
 #     ãã¹2ã®ã¢ã¼ã­ãã¯ãã£ä¾å­ãã³ãã¬ã¼ãï¼ARM-Mç¨ï¼
-# 
-
-# 
+#
+
+#
 #  æå¹ãªå²è¾¼ã¿çªå·ï¼å²è¾¼ã¿ãã³ãã©çªå·
-# 
-$INTNO_VALID = Array(15..$TMAX_INTNO.val)
+#
+$INTNO_VALID = Array(15..$TMAX_INTNO)
 $INHNO_VALID = $INTNO_VALID
 
-# 
+#
 #  æå¹ãªCPUä¾å¤çªå·
 #  7,8ã¯ã¨ãã¥ã¬ã¼ããããä¾å¤
-# 
+#
 $EXCNO_VALID = [ 2,3,4,5,6,7,8,11,12,14 ]
 
-# 
+#
 #  CRE_ISRã§ä½¿ç¨ã§ããå²è¾¼ã¿çªå·ã¨ããã«å¯¾å¿ããå²è¾¼ã¿ãã³ãã©çªå·
-# 
+#
 $INTNO_CREISR_VALID = $INTNO_VALID
 $INHNO_CREISR_VALID = $INHNO_VALID
 
-# 
+#
 #  DEF_INTï¼DEF_EXCã§ä½¿ç¨ã§ããå²è¾¼ã¿ãã³ãã©çªå·ï¼CPUä¾å¤ãã³ãã©çªå·
-# 
+#
 $INHNO_DEFINH_VALID = $INHNO_VALID
 $EXCNO_DEFEXC_VALID = $EXCNO_VALID
 
-# 
+#
 #  CFG_INTã§ä½¿ç¨ã§ããå²è¾¼ã¿çªå·ã¨å²è¾¼ã¿åªå
 åº¦
@@ -96,14 +96,14 @@
 #  ãã®ããï¼ã«ã¼ãã«ç®¡çå¤ã®å²è¾¼ã¿ã§ã®ã¿æå®å¯è½ï¼
 $INTNO_CFGINT_VALID = $INTNO_VALID
-$INTPRI_CFGINT_VALID = Array(-(1 << $TBITW_IPRI.val)..-2)
-
-# 
+$INTPRI_CFGINT_VALID = Array(-(1 << $TBITW_IPRI)..-2)
+
+#
 #  kernel/kernel.tf ã®ã¿ã¼ã²ããä¾å­é¨
-# 
-
-# 
+#
+
+#
 #  TSKINICTXBã®åæåæ
 å ±ãçæ
-# 
+#
 def GenerateTskinictxb(key, params)
    return("{" \
@@ -114,7 +114,7 @@
 end
 
-# 
+#
 #  æ¨æºãã³ãã¬ã¼ããã¡ã¤ã«ã®ã¤ã³ã¯ã«ã¼ã
-# 
+#
 IncludeTrb("kernel/kernel.trb")
 
@@ -124,7 +124,7 @@
  */
 
-/* 
+/*
  *  ãã¯ã¿ã¼ãã¼ãã«
- */ 
+ */
 __attribute__ ((section(".vector")))
 const FP _kernel_vector_table[] = {
@@ -143,5 +143,5 @@
 $INTNO_VALID.each { |inhno|
     #if $cfgData[:DEF_INH][inhno]) && ((INH.INHATR[inhno] & TA_NONKERNEL) != 0)$
-    inh = $cfgData[:DEF_INH].select { |k,v| 
+    inh = $cfgData[:DEF_INH].select { |k,v|
         (v[:inhno] == inhno) && (v[:inhatr] & $TA_NONKERNEL)
     }
@@ -158,5 +158,5 @@
 $kernelCfgC.add("const FP _kernel_exc_tbl[] = {")
 Array(0..14).each { |excno|
-    exc = $cfgData[:DEF_EXC].select { |k,v| 
+    exc = $cfgData[:DEF_EXC].select { |k,v|
         (v[:excno] == excno)
     }
@@ -170,5 +170,5 @@
 }
 $INTNO_VALID.each { |inhno|
-    inh = $cfgData[:DEF_INH].select { |k,v| 
+    inh = $cfgData[:DEF_INH].select { |k,v|
         (v[:inhno] == inhno)
     }
@@ -183,7 +183,7 @@
 $kernelCfgC.add2("};")
 
-# 
+#
 #  _kernel_bitpat_cfgintã®çæ
-# 
+#
 
 bitpat_cfgint_num = 0
@@ -199,5 +199,5 @@
 Array(0..(bitpat_cfgint_num-1)).each { |num|
     Array((num*32)..((num*32)+31)).each { |inhno|
-        inh = $cfgData[:DEF_INH].select { |k,v| 
+        inh = $cfgData[:DEF_INH].select { |k,v|
             (v[:inhno] == inhno)
         }
@@ -210,9 +210,9 @@
 $kernelCfgC.add2("};")
 
-# 
+#
 #  å²è¾¼ã¿åªå
 åº¦ãã¼ãã«ï¼å
 é¨è¡¨ç¾ï¼
-# 
+#
 $kernelCfgC.add("const uint32_t _kernel_int_iipm_tbl[] = {")
 Array(0..14).each { |excno|
@@ -220,5 +220,5 @@
 }
 $INTNO_VALID.each { |intno|
-    int = $cfgData[:CFG_INT].select { |k,v| 
+    int = $cfgData[:CFG_INT].select { |k,v|
         (v[:intno] == intno)
     }
Index: asp3_wo_tecs/trunk/cfg/GenFile.rb
===================================================================
--- asp3_wo_tecs/trunk/cfg/GenFile.rb	(revision 306)
+++ asp3_wo_tecs/trunk/cfg/GenFile.rb	(revision 306)
@@ -0,0 +1,123 @@
+# -*- coding: utf-8 -*-
+#
+#  TOPPERS Configurator by Ruby
+#
+#  Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+#              Graduate School of Information Science, Nagoya Univ., JAPAN
+#  Copyright (C) 2015 by FUJI SOFT INCORPORATED, JAPAN
+#  Copyright (C) 2016 by APTJ Co., Ltd., JAPAN
+#
+#  ä¸è¨èä½æ¨©è
+ã¯ï¼ä»¥ä¸ã®(1)ã(4)ã®æ¡ä»¶ãæºããå ´åã«éãï¼æ¬ã½ããã¦ã§
+#  ã¢ï¼æ¬ã½ããã¦ã§ã¢ãæ¹å¤ãããã®ãå«ãï¼ä»¥ä¸åãï¼ãä½¿ç¨ã»è¤è£½ã»æ¹
+#  å¤ã»åé
+å¸ï¼ä»¥ä¸ï¼å©ç¨ã¨å¼ã¶ï¼ãããã¨ãç¡åã§è¨±è«¾ããï¼
+#  (1) æ¬ã½ããã¦ã§ã¢ãã½ã¼ã¹ã³ã¼ãã®å½¢ã§å©ç¨ããå ´åã«ã¯ï¼ä¸è¨ã®èä½
+#      æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãï¼ãã®ã¾ã¾ã®å½¢ã§ã½ã¼
+#      ã¹ã³ã¼ãä¸­ã«å«ã¾ãã¦ãããã¨ï¼
+#  (2) æ¬ã½ããã¦ã§ã¢ãï¼ã©ã¤ãã©ãªå½¢å¼ãªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+#      ç¨ã§ããå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨
+#      è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®èä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨
+#      ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+#  (3) æ¬ã½ããã¦ã§ã¢ãï¼æ©å¨ã«çµã¿è¾¼ããªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+#      ç¨ã§ããªãå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼æ¬¡ã®ããããã®æ¡ä»¶ãæºããã
+#      ã¨ï¼
+#    (a) åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®è
+#        ä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+#    (b) åé
+å¸ã®å½¢æ
+ãï¼å¥ã«å®ããæ¹æ³ã«ãã£ã¦ï¼TOPPERSãã­ã¸ã§ã¯ãã«
+#        å ±åãããã¨ï¼
+#  (4) æ¬ã½ããã¦ã§ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæ
+#      å®³ãããï¼ä¸è¨èä½æ¨©è
+ããã³TOPPERSãã­ã¸ã§ã¯ããå
+è²¬ãããã¨ï¼
+#      ã¾ãï¼æ¬ã½ããã¦ã§ã¢ã®ã¦ã¼ã¶ã¾ãã¯ã¨ã³ãã¦ã¼ã¶ããã®ãããªãç
+#      ç±ã«åºã¥ãè«æ±ãããï¼ä¸è¨èä½æ¨©è
+ããã³TOPPERSãã­ã¸ã§ã¯ãã
+#      å
+è²¬ãããã¨ï¼
+#
+#  æ¬ã½ããã¦ã§ã¢ã¯ï¼ç¡ä¿è¨¼ã§æä¾ããã¦ãããã®ã§ããï¼ä¸è¨èä½æ¨©è
+ã
+#  ãã³TOPPERSãã­ã¸ã§ã¯ãã¯ï¼æ¬ã½ããã¦ã§ã¢ã«é¢ãã¦ï¼ç¹å®ã®ä½¿ç¨ç®ç
+#  ã«å¯¾ããé©åæ§ãå«ãã¦ï¼ãããªãä¿è¨¼ãè¡ããªãï¼ã¾ãï¼æ¬ã½ããã¦ã§
+#  ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæå®³ã«é¢ãã¦ãï¼ã
+#  ã®è²¬ä»»ãè² ããªãï¼
+#
+#  $Id: GenFile.rb 111 2016-03-16 23:50:27Z ertl-hiro $
+#
+
+#
+#		ãã¡ã¤ã«ä½æã¯ã©ã¹
+#
+
+#
+# ãã¡ã¤ã«ã«æ¸ããã¨ããå
+å®¹ãå¤æ°ã«èç©ãï¼ãã­ã°ã©ã ã®çµäºæï¼output
+# ã¡ã½ãããå¼ã°ããæï¼ã«ãã¡ã¤ã«ã«åºåããï¼æ¢ã«ãã¡ã¤ã«ãå­å¨ãï¼å·®
+# åããªãå ´åã¯åºåããªãï¼ã¿ã¤ã ã¹ã¿ã³ããæ´æ°ããªãï¼ï¼
+#
+class GenFile
+  @@fileDataHash = {}
+
+  def initialize(fileName)
+    @selfFileName = fileName
+    if !@@fileDataHash.has_key?(fileName)
+      @@fileDataHash[@selfFileName] = ""
+    end
+  end
+
+  # ãã¡ã¤ã«ãã¼ã¿ã®æ«å°¾ã«æå­åãè¿½å ãã
+  def append(code = "")
+    @@fileDataHash[@selfFileName] << code
+  end
+
+  # ãã¡ã¤ã«ãã¼ã¿ã«1è¡è¿½å ãã
+  def add(code = "")
+    @@fileDataHash[@selfFileName] << code << "\n"
+  end
+
+  # ãã¡ã¤ã«ãã¼ã¿ã«1è¡è¿½å ãã(æ¹è¡2å)
+  def add2(code = "")
+    add(code + "\n")
+  end
+
+  # ã³ã¡ã³ãããããè¿½å ãã
+  def comment_header(comment)
+    add("/*")
+    comment.split("\n").each do |sLine|
+      add(" *  " + sLine)
+    end
+    add2(" */")
+  end
+
+  # ãã¡ã¤ã«ãã¼ã¿ãè¡¨ç¤ºãã
+  def print()
+    puts(@@fileDataHash[@selfFileName])
+  end
+
+  # å
+¨ãã¡ã¤ã«ãåºåãã
+  def self.output()
+    @@fileDataHash.each do |fileName, fileData|
+      # æ¢ã«ãã¡ã¤ã«ãå­å¨ãï¼å·®åããªãå ´åã¯åºåããªã
+      #ï¼ã¿ã¤ã ã¹ã¿ã³ããæ´æ°ããªãï¼
+      if File.exist?(fileName)
+        if fileData == File.read(fileName)
+          next
+        end
+      end
+      File.open(fileName, "w") do |file|
+        puts("[#{File.basename($0)}] Generated #{fileName}")
+        file.puts(fileData)
+      end
+    end
+  end
+end
Index: asp3_wo_tecs/trunk/cfg/MANIFEST
===================================================================
--- asp3_wo_tecs/trunk/cfg/MANIFEST	(revision 305)
+++ asp3_wo_tecs/trunk/cfg/MANIFEST	(revision 306)
@@ -3,6 +3,6 @@
 pass1.rb
 pass2.rb
+GenFile.rb
+SRecord.rb
 
-common/GenFile.rb
-common/StrVal.rb
-common/SRecord.rb
+doc/cfg_user.txt
